# author:qinguanglei
# ddate:2023/11/20 14:51
import os

from common.logger import log


class ScreenShot(object):
    def __init__(self, driver, module, seq):
        self.driver = driver
        self.module = module
        self.seq = str(seq)

    def screen_shot(self):
        # 设置截图的目录，不存在则创建。
        # 此时目录结构不要随便更改，因为直接与路径挂钩
        # 直接拼接目录
        abs_path = os.path.abspath(__file__)
        # 往上一级到common
        common_dir = os.path.dirname(abs_path)
        # 往上一级到项目目录
        project_dir = os.path.dirname(common_dir)
        # 开始拼接日志目录
        screen_shot = project_dir + os.sep + 'screen_shot' + os.sep + self.module
        # 若该目录不存在则创建该目录
        if not os.path.exists(screen_shot):
            os.mkdir(screen_shot)
            # 页面截图
        # 截图文件文件名
        screen_shot_path = os.path.join(screen_shot, self.seq + '.png')
        # 截图
        self.driver.save_screenshot(screen_shot_path)
